/*		Calls back to HTDaemon program
**		------------------------------
*/
#ifndef HTDAEMON_H
#define HTDAEMON_H

#include "HTFormat.h"
#include "HTAccess.h"
#include "HTSUtils.h"
#include "HTConfig.h"
#include "HTLog.h"


extern BOOL ignore_sigpipes;	/* Should we catch and ignore SIGPIPE	*/
extern BOOL sigpipe_caught;	/* If so, have we caught a SIGPIPE	*/

extern char *		HTClientProtocol;
extern int		HTServerPort;

extern int		HTStatusCode;
extern char *		HTReasonLine;
extern int		HTSoc;
extern char *		HTReqLine;
extern char *		HTReqArg;
extern char *		HTReqArgPath;
extern char *		HTReqArgKeywords;
extern char *		HTReqTranslated;
extern char *		HTReqScript;
extern char *		HTScriptPathInfo;
extern char *		HTScriptPathTrans;
extern char *		HTLocation;
extern char *		HTLastModified;
extern char *		HTExpires;
extern char *		HTUri;
extern char *		HTMessageId;
extern HTList *		HTAllowed;
extern HTList *		HTPublic;
extern char *		HTMetaFile;
extern char *		HTAuthString;
extern char *		HTWWWAuthenticate;
extern HTAAFailReason	HTReason;
extern char *		HTProxyHeaders;
extern char *		HTUserAgent;
extern char *		HTReferer;
extern time_t		HTIfModifiedSince;

extern char *		remote_ident;

extern long		HTCacheUsage;
extern int		HTChildExitStatus;
extern long		HTCachedBytes;
extern int		bytes_from_cache;
extern char *		gc_info_file;
extern time_t		cur_time;

extern BOOL		WWW_VeryVerboseFlag;
#define VTRACE		if(WWW_VeryVerboseFlag)fprintf


/*
 *	These routines are used to send back appropriate
 *	protocol header fields preceding a message.
 */
void HTSendError PARAMS((int		soc, 
			 int		number,
			 CONST char *	msg));

extern void HTSendHeader PARAMS((int		soc, 
				 HTFormat	rep));

int HTLoadRedirection PARAMS((HTRequest * req));
int HTCallScript PARAMS((HTRequest * req));
int HTRetrieve PARAMS((HTRequest * req));
int HTLoadHead PARAMS((HTRequest * req));
int HTPut PARAMS((HTRequest * req));
int HTAnnotate PARAMS((HTRequest * req));
int HTRequest_computeArgs PARAMS((HTRequest * req));
int HTLoadStrToStream PARAMS((HTStream *	sink,
			      CONST char *	str));
int HTCloseStream PARAMS((HTStream * sink));
int HTCopyBodyToFile PARAMS((HTRequest *	req,
			     FILE *		fp));
void HTReLoadRules NOPARAMS;

void compute_server_env NOPARAMS;
void script_timeout_on NOPARAMS;
void output_timeout_on NOPARAMS;
void timeout_off NOPARAMS;

#endif
